/*----------------------------------------------------annotate.c--------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                Vartalaap                                   */
/*----------------------------------------------------------------------------*/
/*                     Multimedia Conferencing Software                       */
/*                                                                            */
/*                                                                            */
/*        Written by:                                                         */
/*                        Yezdezard Lashkari                                  */
/*                        Viswanath Ramachandran                              */
/*                        Sanjay Malpani                                      */
/*                     and                                                    */
/*                        Vijay Talati                                        */
/*                                                                            */
/*                                                                            */
/*                Department of Computer Science and Engineering              */
/*                Indian Institute of Technology, Bombay 400076.              */
/*                                                                            */
/******************************************************************************/


#include	"../common/inc.h"
#include	"../common/protodefs.h"

#define		EXTERN	extern

#include	"clientlib.h"

/*-----------------------------------------------------T_annotate()-----------*/

Status	T_annotate( id, uid, from, to) 
int		id;
int		uid, from, to ;
{

	FD fd= L_sock ;

	/* 	First check for dirty business by the client */
	if(INIT_LIB_FLAG == FALSE)
		FATAL("Library structures NOT initialised");
	/* First check that he is a member of the grp */
	if(IsMember(id) != SUCCESS)
	{
		DEBUG_LEVEL1((stderr,"TRYING TO Annotate GRP NOT MEMBER OF"));
		return(_GroupNotJoined);
	}

	(void)LL_SendAnnotateReq(fd, id, uid, from, to);
	
	return(_NoError);	
}


/*-----------------------------------------------------T_image_mark()---------*/
Status	T_image_mark( id, imageindex, startx,starty,endx,endy, type) 
int		id;
int		imageindex;
int		startx, starty, endx, endy ;
int		type ;
{

	FD fd= L_sock ;

	/* 	First check for dirty business by the client */
	if(INIT_LIB_FLAG == FALSE)
		FATAL("Library structures NOT initialised");
	/* First check that he is a member of the grp */
	if(IsMember(id) != SUCCESS)
	{
		DEBUG_LEVEL1((stderr,"TRYING TO Annotate GRP NOT MEMBER OF"));
		return(_GroupNotJoined);
	}

	(void)LL_SendImagemarkReq(fd, id, imageindex, startx, starty, 
						endx, endy, type);
	
	return(_NoError);	
}

/*------------------------------------------------------End of annotate.c-----*/
