/*----------------------------------------------------------leave.c-----------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                Vartalaap                                   */
/*----------------------------------------------------------------------------*/
/*                     Multimedia Conferencing Software                       */
/*                                                                            */
/*                                                                            */
/*        Written by:                                                         */
/*                        Yezdezard Lashkari                                  */
/*                        Viswanath Ramachandran                              */
/*                        Sanjay Malpani                                      */
/*                  and                                                       */
/*                        Vijay Talati                                        */
/*                                                                            */
/*                                                                            */
/*                Department of Computer Science and Engineering              */
/*                Indian Institute of Technology, Bombay 400076.              */
/*                                                                            */
/******************************************************************************/

/* to leave a talk group	*/

#include	"../common/inc.h"
#include	"../common/protodefs.h"

#define		EXTERN	extern

#include	"clientlib.h"

/*----------------------------------------------------------T_leave()---------*/
Status	T_leave(gid)
int	gid;		/* the group id */
{
	FD fd = L_sock ;
	LeaveGroupReply rep;
	T_GenericReply genrep;

	/* First check for dirty business by the client */
	if(INIT_LIB_FLAG == FALSE)
		FATAL("Library structures NOT initialised");

	(void)LL_SendLeaveGroupReq(fd, gid);
	
	DEBUG_LEVEL2((stderr,"Waitng for LeaveGroup Reply"));

	if(_Reply(fd, _LeaveGroupReply, &genrep) != SUCCESS)
	{
		ERROR("Wrong reply recd ");
		return(_OtherFailure);
	}

	bcopy((char *)&genrep, (char *)&rep, sizeof(T_GenericReply));

	if(rep.success == FALSE)
	{
		ERROR("LeaveGroup Request Failed");
		return(rep.errCode);
	}

	/* else -- it's cool */

	return(_NoError);

}

/*---------------------------------------------------End of leave.c-----------*/

