/*------------------------------------------------process_reqs.c--------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                Vartalaap                                   */
/*----------------------------------------------------------------------------*/
/*                     Multimedia Conferencing Software                       */
/*                                                                            */
/*                                                                            */
/*        Written by:                                                         */
/*                        Yezdezard Lashkari                                  */
/*                        Viswanath Ramachandran                              */
/*                        Sanjay Malpani                                      */
/*                    and                                                     */
/*                        Vijay Talati                                        */
/*                                                                            */
/*                                                                            */
/*                Department of Computer Science and Engineering              */
/*                Indian Institute of Technology, Bombay 400076.              */
/*                                                                            */
/******************************************************************************/

/* This file contains routines which process the requests from the
 * client 
 */

#include	"../common/inc.h"
#include 	"../common/protodefs.h"
#include 	"ex_glbls.h"
#include 	"fncproto.h"
#include 	"localrout.h"

#include	<sys/stat.h>

void	send_image_history() ;
void	make_packet () ;

/*---------------------------------------------ProcessMakeGroupReq()----------*/
/* If space is left, then makes a new group, makes apporpriate  entries
 * in the tables and returns group id
 */
/*----------------------------------------------------------------------------*/
Status	ProcessMakeGroupReq ( client)
FD	client ;
{
	char	*username ;

	int		i ;
	FILE	*hfp ;

	ENTER_PROC("MakeGroupReq recd");

	/* Find a empty group (ie group not yet made )*/
	for ( i=0; i<VNGROUPS; i++ )
	{
		if ( grouptable[i] == NULL)
		{
			/* This group is empty.. make it */

			/* Allocate the memory for the struct */
			grouptable[i] = (GRP_TAB *)Malloc(sizeof(GRP_TAB)) ;

			participantsnumber[i] ++ ;
			
			groupfds[i][0] = client ;
			
			/* Store the participant info  This is the first participant*/
			grouptable[i]->pinfo = getpinfo(client) ;
			grouptable[i]->nxt = NULL ;

			
			/* DO THE INTIAL SETTINGS HERE */
			MessageNumber[i] = 0 ;
			ImageIndex[i] = 0 ;
			CurTxtPos[i][client] = 0 ;

			/* Make the history file for group i , user current*/
		
			vhist_filename[i][client] = tempnam(NULL, "VH") ;

			if (vhist_filename[i][client] == NULL)
				FATAL("Error getting history filename\n") ;

			vhist_file[i][client] = fopen( vhist_filename[i][client], "w") ;
			if (vhist_file[i][client] == NULL)
				FATAL("Error opening for history " ) ;

			/* Write the time and other initial message in the file */
			 /*WORKHERE*/

			return (i) ;
		}
	}

	return(-1) ;
}
				

/*-----------------------------------------------ProcessHistoryReq()----------*/
/* Read the history file of the given group.
 * Send the history data ( text and image) to the requesting
 * client.
 */
/*----------------------------------------------------------------------------*/
void	ProcessHistoryReq( tReq_ptr, client)
T_Req	*tReq_ptr ;
FD	client ;
{
	LL_HistoryReq	ll;

	char	*buf ;
	char	*dbuf ;
	char	*data ;
	char	buff[82] ;
	char	username[82] ;
	T_Data	tdata ;
	int		ln, pkts_left, img_type , fsize;	
	char	ifname[L_tmpnam+2], pkts_left_str[82], img_type_str[82] ;
	struct stat	fbuf ;
	FILE	*fp ;
	FD	*fd_arr;	
	int	n_fds ;
	int	i ;

	ENTER_PROC("ProcessHistoryReq") ;
	DEBUG_LEVEL2((stderr,"HistoryReq recd"));

	/* Coerce request type */
	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req));

	if(DistribSocks((int)ll.gid, &fd_arr, &n_fds, client)!=SUCCESS)
	{
		ERROR("DistribSocks failed");
		CloseDownClient(client);
		return ; /* not reached */
	}

	/* Add the client to the array of fds*/
	fd_arr[n_fds++] = client ;

	for ( i=0; i<n_fds; i++)
	{	
	    fp = fopen(vhist_filename[ll.gid][fd_arr[i]] ,"r+");
		if (fp == NULL)
    	{
        /* Do error processing*/
        return ;
    	}
 
    	/* Allocate memory for stroing the file data */
    	fstat( fileno(fp), &fbuf ) ;
    	fsize = fbuf.st_size ;
    	/* Break if history file size is zero */
    	if ( fsize == 0 )
        	return ;
    	data = (char *)Malloc(( fsize+1)*sizeof(char) ) ;
    	strcpy(data,"\0") ;
 
    	while(!feof(fp) )
    	{
       	 /* Check if the line has image file name */
        	if ( ifname_check(fp) == TRUE )
        	{
           	 fgets(ifname, 80, fp) ;
           	 /* removing the newline */
           	 ifname[strlen(ifname)-1] = '\0' ;
           	 /* Read the image type *//*WORKHERE:80!*/
           	 fgets( img_type_str, 80, fp) ;
           	 img_type_str[strlen(img_type_str) -1] = '\0' ;
           	 img_type = atoi( img_type_str) ;
           	 /* Read the pkts left *//*WORKHERE*/
           	 fgets ( pkts_left_str,80, fp) ;
           	 /* removing the newline */
           	 pkts_left_str[strlen(pkts_left_str)-1] = '\0' ;
           	 pkts_left = atoi(pkts_left_str) ;
	 
   	         /* Read the username */
   	         fgets ( username, 80, fp) ;
   	         username[strlen(username)-1] = '\0' ;
   	         /* Do processing to send image */
   	         send_image_history( client, (int)ll.gid, ifname, 
						pkts_left, username, img_type) ;
   	     	}
   	     	else
   	     	{
   	         buff[0] = '\0' ;
   	         if (fgets(buff, 80, fp) == (char *)EOF)
   	             break ;
   	         if (buff[0] == '\0')
   	         {
   	             break ;
   	         }
   	         strcat( data, buff) ;
   	     	}
   	 }
   	 fclose(fp) ;
	 
   	 /* Break if no data in history file */
   	 if ( strlen(data) == 0 )
   	     continue ;
	 
   	 /* Send the text data */
		tdata.type = _H_Data ;
		tdata.nBytesUser = htons(0) ;
		tdata.gid = ll.gid ;
		tdata.userid = fd_arr[i] ;
		tdata.nBytesData = htonl(strlen(data)) ;
	
		ln = sizeof(T_Data) + ((strlen(data)+3) & ~ 3) ;
		dbuf = (char *)Malloc(ln) ;
		make_packet(&tdata, data, &dbuf) ;
	
		WriteToClient(client, ln, (char*)dbuf) ;
	
		Free(dbuf) ;
		Free(data) ;
	}

	return ;
}


/*----------------------------------------------ProcessUserListReq()----------*/
/* Read the participants info table and
 * send the data to the requesting client
 */
/*----------------------------------------------------------------------------*/
void	ProcessUserListReq ( tReq_ptr, client)
T_Req	*tReq_ptr ;
FD	client ;	
{

	LL_UserListReq	ll;

	char	*buf ;
	int	id ;
	GRP_TAB	*ptr ;

	DEBUG_LEVEL1((stderr,"UserListReq recd"));

	/* Coerce request type */
	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req));

	UserListClnt = client ;

	id = ll.gid ;		

	/* Now form the userlist data chunk from GRP_TAB. Right now only 
		sending names. When desc and photos will be incorporated, this 
		will become slightly complex. ( Might have to packetize) .
	*/

	/* First get the memory to store names*/
	buf = (char *)Malloc ( MAXNAMESZ*MAXPARTICIPANTS*sizeof(char)) ;

	strcpy(buf," ") ;
	ptr = grouptable[id] ;

	while ( ptr != NULL )
	{
		strcat(buf,ptr->pinfo->Name) ;
		strcat(buf," ") ;
		
		ptr = ptr->nxt ;
	}	

	SendUserListData( client, buf) ;

	Free(buf) ;

}
		

/*----------------------------------------------ProcessAnnotateReq()----------*/
/* Process the mark request. Send the mark command to all
 * other users of the group.
 */
/*----------------------------------------------------------------------------*/
void	ProcessAnnotateReq ( tReq_ptr, client)
T_Req	*tReq_ptr ;
FD	client ;
{
	LL_AnnotateReq	ll;
	A_Data		ad ;
	FD	*fd_arr;	
	int	n_fds ;
	int	ln, j ;

	char	*buf ;

	DEBUG_LEVEL1((stderr,"AnnotateReq recd"));

	/* Coerce request type */
	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req));

	/* The A_Data sturct*/
	ad.type = _A_Data ;
	ad.userid = ll.userid ;
	ad.From = (ll.From );
	ad.To = (ll.To );
	ad.gid = ll.gid ;
DEBUG_LEVEL3((stderr,"userid=%d, from=%d, to=%d,\n", ad.userid, ad.From, ad.To )) ;

	DEBUG_LEVEL3((stderr,"[SERVER]:Before DistribSocks\nID:%d\n",ad.gid));
					
	if(DistribSocks((int)ad.gid, &fd_arr, &n_fds, client)!=SUCCESS)
	{
		ERROR("DistribSocks failed");
		CloseDownClient(client);
		return ; /* not reached */
	}

	DEBUG_LEVEL3((stderr,"[SERVER]:Ann:After DistribSocks\nfds retd:%d\n",n_fds));

	ln= sizeof(A_Data) ;
	buf = (char *)Malloc(ln);
	bcopy((char *)&ad, (char *)buf, sizeof(A_Data));

	for( j = 0; j < n_fds ; j++)
	{
	FD	fdd;

	/* Dont send him back data he sent us */

	if((fdd = (FD)fd_arr[j]) == client )
		continue ;

	fdd = fd_arr[j];
	DEBUG_LEVEL3((stderr,"Writing A_Data to FD:%d\n", fdd));
	
	WriteToClient(fdd, ln, (char *)buf);

	}

	Free(buf) ;

}

/*---------------------------------------------ProcessImagemarkReq()----------*/
/* Process the image mark req. 
 * Send mark to all other clients of the group
 */
/*----------------------------------------------------------------------------*/
void	ProcessImagemarkReq ( tReq_ptr , client)
T_Req	*tReq_ptr ;
FD	client ;
{
	LL_ImagemarkReq	ll;
	IM_Data		ad ;
	FD	*fd_arr;	
	int	n_fds ;
	int	ln, j ;
	char	*buf ;

	DEBUG_LEVEL2((stderr,"ImagemarkReq recd"));

	/* Coerce request type */
	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req));

DEBUG_LEVEL3((stderr,"LOCAL got IM sx= %d, sy=%d, ex=%d, ey=%d \n",
		ll.startx, ll.starty, ll.endx, ll.endy) );


	/* The IM_Data sturct*/
	ad.type = _IM_Data ;
	ad.startx = (ll.startx );
	ad.endx = (ll.endx );
	ad.starty = (ll.starty );
	ad.endy = (ll.endy );
	ad.ImgIndx = ll.ImgIndx ;
	ad.gid = ll.gid ;
	ad.mark_type = ll.type ;

	DEBUG_LEVEL3((stderr,"[LOCAL]:Before DistribSocks\nID:%d, %d sx..%d %d %d %d\n",ad.gid, ad.ImgIndx, ad.startx, ad.starty, ad.endx, ad.endy));
					
	if(DistribSocks(ad.gid, &fd_arr, &n_fds, client)!=SUCCESS)
	{
		ERROR("DistribSocks failed");
		CloseDownClient(client);
		return ;	/* not reached */

	}

	DEBUG_LEVEL3((stderr,"[LOCAL]:IM:After DistribSocks\nfds retd:%d\n",
			n_fds));

 	ln = sizeof(IM_Data) ;
	buf = (char *)Malloc(ln);
	bcopy((char *)&ad, (char *)buf,
		sizeof(IM_Data));

	for( j = 0; j < n_fds ; j++)
	{
	FD	fdd;

	/* Dont send him back data he sent us */

	if((fdd = (FD)fd_arr[j]) == client )
		continue ;

	fdd = fd_arr[j];
	DEBUG_LEVEL3((stderr,"Writing I_Data to FD:%d\n", fdd));

	WriteToClient(fdd, ln, (char *)buf);

	}

	Free(buf);
}


/*---------------------------------------------ProcessJoinGroupReq()----------*/
/* Process the request to join a group.
 */
/*----------------------------------------------------------------------------*/
Status	ProcessJoinGroupReq ( tReq_ptr, client, idptr)
T_Req	*tReq_ptr ;
FD		client ;
int		*idptr ;
{
	LL_JoinGroupReq	ll;
	JoinGroupReply rep;
	char	*username ;
	char	*buf, *pBuf ;
	Status 	st ;
	int		i ;
	GRP_TAB	*newelem, *ptr ;
	
	DEBUG_LEVEL2((stderr,"JoinGroupReq recd"));
	
	/*Get the user name */
	UserName(client, &username ) ;
	
	/* Coerce request type */
	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req));

	(*idptr) = ll.gid ;

	if (((*idptr)<0) || ((*idptr) >=VNGROUPS))
		return(_NoSuchGroup);

	if ( participantsnumber[(*idptr)] == 0 )
		/* Group not yet made , return error */
		return(_NoSuchGroup);

	if ( participantsnumber[(*idptr)] >= MAXPARTICIPANTS)
		/*ENOUGH*/
		return(_NoSpaceLeft) ;

	/* Check if group Already Joined */
	for(i=0; i<participantsnumber[(*idptr)]; i++)
	{
		if ( groupfds[(*idptr)][i] ==client)
			return(_GroupAlreadyJoined) ;
	}


	/* Join the group */

	/* Update the tables */

	groupfds[(*idptr)][participantsnumber[(*idptr)]] = client ;
	participantsnumber[(*idptr)] ++ ;
	CurTxtPos[(*idptr)][client] = 0 ;

	/* Make the history file for group i , user current*/
		
	vhist_filename[(*idptr)][client] = tempnam(NULL, "VH") ;

	if (vhist_filename[(*idptr)][client] == NULL)
		FATAL("Error getting history filename\n") ;

	vhist_file[(*idptr)][client] 
				= fopen( vhist_filename[(*idptr)][client], "w") ;
	if (vhist_file[(*idptr)][client] == NULL)
		FATAL("Error opening for history " ) ;

	/* Write the time and other initial message in the file */
	 /*WORKHERE*/

	
	newelem = (GRP_TAB *)Malloc( sizeof(GRP_TAB)) ;
	
	newelem->pinfo = getpinfo( client) ; 
	newelem->nxt = NULL ;

	ptr = grouptable[(*idptr)] ;
	for (i=0 ; i<MAXPARTICIPANTS; i++)
	{
		
		if (ptr->nxt == NULL)
			break ;
		ptr = ptr->nxt ;
	}
	ptr->nxt = newelem ;

	return(_NoError) ;	
	
}


/*--------------------------------------------ProcessLeaveGroupReq()----------*/
/* Process the reuest to Leave a group
 */
/*----------------------------------------------------------------------------*/
Status	ProcessLeaveGroupReq( tReq_ptr , client , n_fds_ptr, fd_arr_ptr, id_ptr)
T_Req	*tReq_ptr ;
FD	client ;
int	*n_fds_ptr ;
FD	**fd_arr_ptr ;
int	*id_ptr ;
{	
	LL_LeaveGroupReq	ll;
	Status	st ;
	int		id ;
	int		i ;
	char	ifname[L_tmpnam + 2] ;
	char	buff[82] ;
	FILE	*fp ;

	ENTER_PROC("ProcessLeaveGroupReq") ;
	DEBUG_LEVEL2((stderr,"LeaveGroupReq recd"));
	
	/* Coerce request type */
	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req));

	id = ll.gid ;

	/* First get the gorupfds of current group.. required later to send
		leave indication*/
	if(DistribSocks((int)id, fd_arr_ptr, n_fds_ptr, client) != SUCCESS)
	{
		ERROR("DISTRIBSOCKS FAILED");
		CloseDownClient(client) ;
		return; /*WORKHERE*/ 
	}

	(*id_ptr) = id ;

	if ( removefromgroupfds( client, id) < 0 )
		/*WORKHERE*/ 		 
		return(-1) ;

	/* Remove the user's data from the list */
	deleteuser( client, id) ;

	/* If  no more participants in the group, we close the group.
	   So remove the temporary files of the group */
	if (participantsnumber[id] == 0 )
	{
		for (i=0; i<MAX_PARTICIPANTS_PER_SESSION; i++)
			if (vhist_filename[id][i] != NULL)
			{

				/* Scan the file and get the image files generated.
					Remove those image files*/
				fp = fopen(vhist_filename[id][i],"r") ;
				if ( fp != NULL)
				{
					while(!feof(fp))
					{
						if ( ifname_check(fp) == TRUE )
						{
							fgets(ifname, 80, fp) ;
							/* removing the newline */
							ifname[strlen(ifname)-1] = '\0' ;
							unlink(ifname) ;
						}
   	     				else
   	     				{
   	         				buff[0] = '\0' ;
   	         				if (fgets(buff, 80, fp) == (char *)EOF)
   	             				break ;
   	         				if (buff[0] == '\0') /*WORKHERE*/
   	             				break ;
						}
					}
					fclose(fp) ;
				}
				/*delete the file*/
				unlink(vhist_filename[id][i]) ;
				/* release space*/
				free(vhist_filename[id][i]) ;
				/* make if NULL */
				vhist_filename[id][i]= NULL ;
			}
	}
		
		

	return(SUCCESS) ;
	
}


/*--------------------------------------------------------getpinfo()----------*/
/* Get the pointer into the participants info table of the user who is
 * connected on a given fd
 */
/*----------------------------------------------------------------------------*/
PARTICIPANTS_INFO	*getpinfo( fd)
FD	fd ;
{

	int	i ;

	for (i=0; i<MAXPARTICIPANTS; i++)
	{

		if ( pinfo[i].fd == fd)
			return(&pinfo[i]) ;
	}
	return(NULL) ;
}

/*----------------------------------------------removefromgroupfds()----------*/
/* Remove the fd from the list of fds of group
 */
/*----------------------------------------------------------------------------*/
Status	removefromgroupfds( client, id)
FD		client;
int		id ;
{

	int	i, j;
	
	for ( i =0; i< participantsnumber[id]; i++)
	{
		if ( groupfds[id][i] == client)
		{
			/* Pack the array */
			for ( j=i; j<participantsnumber[id]-1; j++)
				groupfds[id][j] = groupfds[id][j+1] ;

			participantsnumber[id]-- ;
			return( SUCCESS) ;
		}
	}
	return(FAILURE) ;
}


/*------------------------------------------------------deleteuser()----------*/
/* Remove the entry of user from the grouptable (a linked list)
 */
/*----------------------------------------------------------------------------*/
deleteuser( client, id)
FD		client ;
int		id ;
{

	GRP_TAB	*ptr, *prev_ptr ;
	int		i ;

	DEBUG_LEVEL2((stderr,"In deleteuser \n" ));
	
	ptr = grouptable[id] ;
	prev_ptr = NULL ;
		
	for (i=0 ; i<=participantsnumber[id]; i++)
	{
	
		if ( ptr->pinfo->fd == client)
		{
			if ( ptr == grouptable[id] ) /* First in the list */
				grouptable[id] = (GRP_TAB *)NULL ;
			else
				prev_ptr->nxt = ptr->nxt ;

			return ;
		}
		prev_ptr = ptr ;
		ptr = ptr->nxt ;
	}
}
	
			
	
/*----------------------------------------------ProcessSendDataReq()----------*/
/* The Request to send data is processed.
 * Data is also written in History files.
 */
/*----------------------------------------------------------------------------*/
void	ProcessSendDataReq( tReq_ptr , client )
T_Req	*tReq_ptr ;
FD	client ;
{

	LL_SendDataReq	ll ;
	char			*buf , *pBuf, *data ;
	char			*uname ;
	int				ln ,j,i;
	SendReply		srep ;
	FD				*fd_arr ;
	int				n_fds ;
	T_Data			td ;
	

	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req)) ;

	/* Read in the Data */
	{
	int	len ;
	
	len = (ntohs(ll.nBytes) +3 ) & ~3 ;
	data	= (char *)Malloc(len) ;

	ReadBuffer(client, data, len) ;
	}

	
	/* Set up the indexes */
	if ( tReq_ptr->reqType == _SendDataReq) 
	{
		CurTxtPos[ll.gid][client]+=ll.nBytes ;
		MessageNumber[ll.gid]++ ;	
	}
	else	if (tReq_ptr->reqType == _ImageDataReq)
		ImageIndex[ll.gid] ++ ;

	/* Audio ?? */

	/* Get the username */
	UserName( client, &uname) ;

	/* Increment the position*/
	/* Write the data into History File */
	if ( tReq_ptr->reqType == _SendDataReq)
		WriteHistFileText( ll.gid, client, data) ;
	else	if (tReq_ptr->reqType == _ImageDataReq)
		WriteHistFileImage( ll.gid, client, ll.image_type, ntohs(ll.pkts_left), 
			uname, data, ntohs(ll.nBytes)) ;
	
		
	/* Fill in the tdata struct. to send */
	if (tReq_ptr->reqType == _ImageDataReq)
		td.type = _I_Data ;
	else 
	if (tReq_ptr->reqType == _SendDataReq)
		td.type = _T_Data ;
	else
	if (tReq_ptr->reqType == _BBoardObjReq)
		td.type = _BB_Data ;

	td.image_type = ll.image_type 	; 	
	td.gid = ll.gid ;
	td.userid = client ;
	td.nBytesData = (ll.nBytes );
	td.pkts_left = (ll.pkts_left );
	td.nBytesUser = strlen(uname ) ;
	td.MsgNum = MessageNumber[ll.gid] ; 
	td.ImgIndx = ImageIndex[ll.gid] ; 

	/* Find out the clients of the group */
	if(DistribSocks((int)td.gid, &fd_arr, &n_fds, client) != SUCCESS)
	{
		ERROR("DISTRIBSOCKS FAILED") ;
		CloseDownClient(client) ;
		return ;
	}

	ln = sizeof(T_Data) + ((ntohl(td.nBytesData) +3) & ~3) +
					((ntohs(td.nBytesUser) + 3) & ~3) ;

	/* Make the packet to send */
	buf = (char *)Malloc(ln) ;
	pBuf = buf ;
	bcopy((char *)&td, (char *)buf, sizeof(T_Data)) ;
	pBuf += sizeof(T_Data) ;

	/*Copy the data*/
	bcopy((char *)data, (char *)pBuf, ntohl(td.nBytesData)) ;
	pBuf += ntohl(td.nBytesData );
	i = padlength[ntohl(td.nBytesData) & 3] ;
	while (--i >= 0)
		*pBuf++ = 0 ;

	/* The user name */
	bcopy((char *)uname, (char *)pBuf, ntohs(td.nBytesUser) ) ;
	pBuf += ntohs(td.nBytesUser) ;
	i = padlength[ntohs(td.nBytesUser) & 3] ;
	while( --i >= 0)
		*pBuf++ = 0 ;

	/* Sending to all clients */
	for ( j=0; j<n_fds; j++)
	{
	
	/* Dont send it back to originator */
	if ((FD)fd_arr[j] == client)
		continue ;

	WriteToClient( fd_arr[j], ln, (char *)buf) ;
	}

	Free(buf) ;
	Free(data) ;

	if(tReq_ptr->reqType == _SendDataReq)
	{
		srep.type = _T_Reply ;
		srep.opcode = _SendReply ;
		srep.MsgNum = htons(MessageNumber[ll.gid]) ;
		buf = (char *)Malloc(sizeof(SendReply)) ;
		
		bcopy((char *)&srep, (char *)buf, sizeof(SendReply)) ;

		WriteToClient( client, sizeof(SendReply), (char *)buf) ;
		Free( buf) ;
	}

	return  ;
}

/*----------------------------------------------ProcessSendBBObjReq()_--------*/
/* The Request to send bbobj is processed.
 */
/*----------------------------------------------------------------------------*/
void	ProcessSendBBObjReq( tReq_ptr , client )
T_Req	*tReq_ptr ;
FD	client ;
{

	LL_BBoardObjReq	ll ;
	char			*buf , *pBuf, *data ;
	char			*uname ;
	int				ln ,j,i;
	SendReply		srep ;
	FD				*fd_arr ;
	int				n_fds ;
	BB_Data			bd ;
	

	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req)) ;

	/* Read in the Data */
	{
	int	len ;
	
	len = (ll.nBytes +3 ) & ~3 ;
	data	= (char *)Malloc(len) ;

	ReadBuffer(client, data, len) ;
	}
	
	/* Get the username */
	UserName( client, &uname) ;

	/* Fill in the tdata sturct. to send */
	
	bd.type = _BB_Data ;
	bd.obj_type = ll.obj_type 	; 	
	bd.gid = ll.gid ;
	bd.nBytesData = (ll.nBytes );
	bd.lstyle = ll.lstyle ;
	bd.fstyle = ll.fstyle ;
	bd.lwidth = (ll.lwidth );
	bd.color = ll.color ;
	bd.nBytesUser = htons(strlen(uname )) ;

	/* Find out the clients of the group */
	if(DistribSocks((int)bd.gid, &fd_arr, &n_fds, client) != SUCCESS)
	{
		ERROR("DISTRIBSOCKS FAILED") ;
		CloseDownClient(client) ;
		return ;
	}

	ln = sizeof(T_Data) + ((ntohl(bd.nBytesData) +3) & ~3) +
					((ntohs(bd.nBytesUser) + 3) & ~3) ;

	/* Make the packet to send */
	buf = (char *)Malloc(ln) ;
	pBuf = buf ;
	bcopy((char *)&bd, (char *)buf, sizeof(T_Data)) ;
	pBuf += sizeof(T_Data) ;

	/*Copy the data*/
	bcopy((char *)data, (char *)pBuf, ntohl(bd.nBytesData)) ;
	pBuf += ntohl(bd.nBytesData );
	i = padlength[ntohl(bd.nBytesData) & 3] ;
	while (--i >= 0)
		*pBuf++ = 0 ;

	/* The user name */
	bcopy((char *)uname, (char *)pBuf, ntohs(bd.nBytesUser )) ;
	pBuf += ntohs(bd.nBytesUser );
	i = padlength[ntohs(bd.nBytesUser) & 3] ;
	while( --i >= 0)
		*pBuf++ = 0 ;

	/* Sending to all clients */
	for ( j=0; j<n_fds; j++)
	{
	
	/* Dont send it back to originator */
	if ((FD)fd_arr[j] == client)
		continue ;

	WriteToClient( fd_arr[j], ln, (char *)buf) ;
	}

	Free(buf) ;
	Free(data) ;

	return  ;
}

/*----------------------------------------------ProcessSendBBCharReq()--------*/
/* The Request to send blackboard char is processed.
 */
/*----------------------------------------------------------------------------*/
void	ProcessSendBBCharReq( tReq_ptr , client )
T_Req	*tReq_ptr ;
FD	client ;
{

	LL_BBoardCharReq	ll ;
	char			*buf , *pBuf, *data ;
	char			*uname ;
	int				ln ,j,i;
	SendReply		srep ;
	FD				*fd_arr ;
	int				n_fds ;
	BB_Char			bd ;
	

	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req)) ;

	/* Get the username */
	UserName( client, &uname) ;

	/* Fill in the tdata sturct. to send */
	
	bd.type = _BB_Char ;
	bd.letter = ll.letter 	; 	
	bd.gid = ll.gid ;
	bd.pos_x = (ll.pos_x );
	bd.pos_y = (ll.pos_y );
	bd.font_style = ll.font_style ;
	bd.color = ll.color ;
	bd.font_family = ll.font_family ;
	bd.font_size = ll.font_size ;
	
	/*bd.nBytesUser = strlen(uname ) ;*/

	/* Find out the clients of the group */
	if(DistribSocks((int)bd.gid, &fd_arr, &n_fds, client) != SUCCESS)
	{
		ERROR("DISTRIBSOCKS FAILED") ;
		CloseDownClient(client) ;
		return ;
	}

	ln = sizeof(BB_Char)  ;

	/* Make the packet to send */
	buf = (char *)Malloc(ln) ;
	bcopy((char *)&bd, (char *)buf, sizeof(BB_Char)) ;

	/* Sending to all clients */
	for ( j=0; j<n_fds; j++)
	{
	
	/* Dont send it back to originator */
	if ((FD)fd_arr[j] == client)
		continue ;

	WriteToClient( fd_arr[j], ln, (char *)buf) ;
	}

	Free(buf) ;
	Free(data) ;

	return  ;
}



/*-----------------------------------------------WriteHistFileText()----------*/
/* Write text data in history file
 * If file size increase beyond a certain limit, truncate from head.
/*----------------------------------------------------------------------------*/

void	WriteHistFileText( grpid, userid, data)
int		grpid ;
int		userid ;
char	*data ;
{
	int	fsize ;
	struct	stat fbuf ;
	char	buff[MAX_FILE_SZ+5], *tempptr ;
	int	diff , i;
	char	c ;
	FILE	*fp ;

	fp = vhist_file[grpid][userid] ;
	fstat( fileno(fp), &fbuf) ;
	fsize = fbuf.st_size ;
	/* Check is size exceeds */
	if ( (fsize + strlen(data)) > MAX_FILE_SZ )
	{
		fclose(fp) ;
		/*Open in read mode */
		fp = fopen(vhist_filename[grpid][userid], "r") ;
		/* Truncate the file from top */
		diff = fsize+strlen(data) - MAX_FILE_SZ ;
		i = 0 ;
		while ((i++ ) < diff )
			fgetc(fp) ;
		/*Skip to next newline */
		while ( fgetc(fp) != '\n') ;
		/* Store the remaining into temp. buffer */
		tempptr = buff ;
		while ((c=fgetc(fp)) != EOF )
		{
			(*tempptr) = c ;
			tempptr++ ;
		}
		fclose(fp) ;
		/* Append the new data */
		sprintf( tempptr, "%s", data) ;
	
		/*Rewrite the file */
		fp = fopen(vhist_filename[grpid][userid], "w") ;
		if ( fp == NULL )
		{
		/* Do error processing here */
		/*WORKHERE*/
		}
		vhist_file[grpid][userid] = fp ;
		
		fputs(buff, fp) ;
		fflush(fp) ;

		return ;
	}
	else
	{
		fseek(fp,0,2); /* Goto end of file*/
		fprintf (fp, "%s", data) ;
		fflush(fp) ;
		fflush(fp) ;
		return ;
	}
}

/*----------------------------------------------WriteHistFileImage()----------*/
/* Write the image packet in a file and write the filename
 * in the history file
 */
/*----------------------------------------------------------------------------*/
void	WriteHistFileImage( grpid, userid, imgtype, pktsleft, usrname, data, datasize)
int		grpid ;
int		userid ;
int		imgtype ;
int		pktsleft ;
char	*usrname ;
char	*data ;
int		datasize ;
{

	char	*ifname ;
	FILE	*fp;

	/* Store the image and write the image
	file name into orig. hist. file */
					
	/* Create temp file name */
	/* File name for hist image file */
	ifname = tempnam(NULL,"VHI") ;

	fp = vhist_file[grpid][userid] ;
				
	/* Write the image file name into history file */	
	if (fp !=NULL)
	{
		/* Goto end of file*/ 
		fseek(fp,0,2); 
		/* Set the char showing that the foll is image file name*/
		fprintf(fp,"\n") ;
		fputc( ImageFileFlag, fp ) ;
		fprintf(fp,"%s\n", ifname) ;

		/* The type of image */
		fprintf(fp," %d\n", imgtype) ;

		/* Also put the pkts_left for image*/
		fprintf(fp, " %d\n",pktsleft) ;

		/* Write the sender's name */
		/* Will be redundantly written after each packet, but lets
			live with it */
		fprintf(fp,"%s \n", usrname) ;

		fflush(fp) ;
	}

	/*Write the image data into image file*/
	if ((fp = fopen(ifname, "w")) != NULL)
	{
		write( fileno(fp), data, datasize) ;	
		fflush(fp) ;
		fclose(fp) ;
	}

	free(ifname) ;
}


	
/*--------------------------------------------ProcessAudioStartReq()----------*/
/* Check if audio_channel is free. If free, open a socket, bind it to audio
 * port. Send a command to all other users of the group to connect to
 * audio channel and send ack to requesting user.
/*----------------------------------------------------------------------------*/
Status	ProcessAudioStartReq( tReq_ptr, portptr, idptr)  
T_Req	*tReq_ptr ;
int		*portptr ;
int		*idptr ;
{

	LL_SendDataReq	ll ;
	char			*buf , *pBuf, *data ;
	int				id ;

	ENTER_PROC("ProcessAudioStartReq") ;
	

	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req)) ;

	id = ll.gid ;
	(*idptr) = id ;

	/* Check if the audio_channel of the requested group is free*/

	if (audio_channel_status[id] == BUSY)
	{
		/*Reject the request */
		return(FAILURE) ;
	}
	audio_channel_status[id] = BUSY ;

	/* Otherwise , open the socket and send the port and address to client*/

	ausockfd = setport(AUDIO_PORT) ;
	if ( (ausockfd) < 0 )
		return(FAILURE) ;

	(*portptr) = AUDIO_PORT ; /*WORKHERE*/ 
	return(SUCCESS) ;
}

/*----------------------------------------------------setport()----------*/
/* Open and bind a  port
 */
/*----------------------------------------------------------------------------*/
FD	setport(port)
int	port ;
{
	FD	s ;
	struct sockaddr_in	aserver ;

	s = socket(AF_INET, SOCK_STREAM, 0) ;

	if (s < 0 )
		return(s) ;

	(void) setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *)NULL, 0) ;
	/*(void) setsockopt(s, SOL_SOCKET, SO_USELOPBACK, (char *)NULL, 0) ;*/

	aserver.sin_family 		= AF_INET ;
	aserver.sin_addr.s_addr = htonl(INADDR_ANY) ;
	aserver.sin_port		= port ;

	bind(s, (struct sockaddr *)&aserver, sizeof(aserver)) ;

	listen(s, 5) ;

	return (s) ;
}


/*-----------------------------------------------SendAudioStartCmd()----------*/
/* Send a command to all other users to connect to
 * the audio port
 */
/*----------------------------------------------------------------------------*/
void	SendAudioStartCmd( client, id, port) 
FD		client ;
int		id ;
int		port ;
{

	AS_Data		asc ;
	struct	sockaddr_in	cli_addr ;
	int		clilen ;
	FD		ausock ;
	int		aufds_count ;
	int		n_fds ;
	FD		*fd_arr ;
	int		j ;
	char	*buf ;
	int		ln ;
	

	ENTER_PROC("SendAudioStartCmd") ;

	/* Do a DistribSocks to find out all the client fds in the group */
	if (DistribSocks(id, &fd_arr, &n_fds, client) != SUCCESS)
	{

		/*WORKHERE*/ /*What about the audio channel ?? */
		ERROR("DistribSocks failed") ;
		CloseDownClient(client) ;
		return ;
	}

	/* Prepare the AudioStartCmd packet */
	asc.type = _AS_Data ;
	asc.port = port ;
	asc.gid = id ;

	ln = sizeof(AS_Data) ;
	buf = (char *)Malloc(ln) ;
	bcopy((char *)&asc, (char *)buf, sizeof(AS_Data) ) ;

	/* Send the command to all fds except the client ( originator) */
	for ( j=0; j< n_fds; j++)
	{
	
		if (fd_arr[j] == client) 
			continue ;
		WriteToClient( fd_arr[j], ln, (char *)buf) ;
	}
	Free(buf) ;

	/* Wait for connections from these fds */
	aufds_count =  0;
	for ( j=0 ; j<n_fds; j++)
	{
		ausock = accept(ausockfd, (struct sockaddr *)&cli_addr, &clilen) ;
		if (ausock < 0)
		{
			perror("Server: accept error on audio socket ") ;
			CloseDownServer () ; /*WORKHERE*/ 
		}

		/*Add the fd to the audio fds array */
		groupaufds[id][aufds_count++] = ausock ;
	}


	return ;
}

/*---------------------------------------------ProcessAudioDataReq()----------*/
/*----------------------------------------------------------------------------*/
void	ProcessAudioDataReq( tReq_ptr, client)
T_Req	*tReq_ptr ;
FD				client ;
{

	LL_SendDataReq	ll ;
	char			*buf, *pBuf, *data ;
	char			*uname ;
	int				ln, j, i;
	FD				*fd_arr ;
	int				n_fds ;
	T_Data			td ;

	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req)) ;
	
	/*Read the Data from Audio Port */
	{
	int	len ;

	len = (ll.nBytes + 3) & ~3 ;
	data = (char *)Malloc(len) ;
	
	ReadBuffer(client, data, len) ;
	}

	/* Do any server data update here*//*WORKHERE*/ 	

	
	/* HISTORY FILE *//*WORKHERE*/ 

	td.type = _V_Data ;
	td.image_type = ll.image_type ;
	td.gid = ll.gid ;
	td.nBytesData	= ll.nBytes ;
	td.pkts_left = ll.pkts_left ;
	td.nBytesUser = 0 ;
	td.MsgNum  = 0 ;/*WORKHERE*/	


	/*Find out the clients of the group */
	if(DistribAuSocks((int)td.gid, &fd_arr, &n_fds, client) != SUCCESS)
	{
		ERROR("DISTRIBSOCKS FAILED") ;
		CloseDownClient(client) ;
		return ;
	}

	ln = sizeof(T_Data) + ((td.nBytesData +3) & ~3) +
			((td.nBytesUser + 3) & ~3) ;

	/* Make the packet to send */
	buf = (char *)Malloc(ln) ;
	pBuf = buf ;
	bcopy((char *)&td, (char *)buf, sizeof(T_Data)) ;
	pBuf += sizeof(T_Data) ;

	/*Copy the data*/
	bcopy((char *)data, (char *)pBuf, td.nBytesData) ;
	pBuf += td.nBytesData;
	i = padlength[td.nBytesData & 3] ;
	while ( --i >= 0) 
		*pBuf++ = 0 ;
	/*Sending to all clients*/
	for(j=0; j<n_fds-1; j++)
	{
		if((FD)fd_arr[j] == client)
			continue ;

		WriteToClient( fd_arr[j], ln, (char *)buf) ;
	}

	Free(buf) ;
	Free(data) ;
	return ;
	
}

/*---------------------------------------------ProcessAudioStopReq()----------*/
/*----------------------------------------------------------------------------*/
void	ProcessAudioStopReq( tReq_ptr, client)
T_Req	*tReq_ptr ;
FD				client ;
{
	LL_SendDataReq	ll ;
	int		id ;
	int		i ;

	bcopy((char *)&ll, (char *)tReq_ptr, sizeof(T_Req));

	id = ll.gid ;

	/*Send a audistop command to all connected clients*/
	/*WORKHERE*/	


	/* Close all fds of groupaufds*/
	close(client) ;
	RemoveFD(client) ;

	for(i=0; i< participantsnumber[id]-1; i++)
	{
		close(groupaufds[id][i]) ;
	}

	/* Set audio_channel free*/	
	audio_channel_status[id] = FREE ;
}
	
/*--------------------------------------------ProcessImageStartReq()----------*/
/* Check if image_channel is free. If free, open a socket, bind it to image
 * port. Send a command to all other users of the group to connect to
 * image channel and send ack to requesting user.
/*----------------------------------------------------------------------------*/
Status	ProcessImageStartReq( tReq_ptr, portptr, idptr)  
T_Req	*tReq_ptr ;
int		*portptr ;
int		*idptr ;
{

	LL_SendDataReq	ll ;
	char			*buf , *pBuf, *data ;
	int				id ;

	ENTER_PROC("ProcessImageStartReq") ;
	

	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req)) ;

	id = ll.gid ;
	(*idptr) = id ;

	/* Check if the image_channel of the requested group is free*/
	if (image_channel_status[id] == BUSY)
	{
		/*Reject the request */
		return(FAILURE) ;
	}
	image_channel_status[id] = BUSY ;

	/* Otherwise , open the socket and send the port and address to client*/
	imgsockfd = setport(SERVER_IMAGE_BASE_PORT+ImagePort) ;
	if ( (imgsockfd) < 0 )
		return(FAILURE) ;

	(*portptr) = SERVER_IMAGE_BASE_PORT+ImagePort ; 
	return(SUCCESS) ;
}

/*-----------------------------------------------SendImageStartCmd()----------*/
/* Send a command to all other users to connect to
 * the image port
 */
/*----------------------------------------------------------------------------*/
void	SendImageStartCmd( client, id, port) 
FD		client ;
int		id ;
int		port ;
{

	IS_Data		asc ;
	struct	sockaddr_in	cli_addr ;
	int		clilen ;
	FD		isock ;
	int		imgfds_count ;
	int		n_fds ;
	FD		*fd_arr ;
	int		j ;
	char	*buf ;
	int		ln ;
	

	ENTER_PROC("SendImageStartCmd") ;

	/*WORKHERE*/	
	/* Find a better way of doing this. Need some way of associating
		image fds ( also audio fds) wiht the original ctrl fds of clients*/
	ImageGenFD[id] = client ;


	/* Do a DistribSocks to find out all the client fds in the group */
	if (DistribSocks(id, &fd_arr, &n_fds, client) != SUCCESS)
	{

		/*WORKHERE*/ /*What about the audio channel ?? */
		ERROR("DistribSocks failed") ;
		CloseDownClient(client) ;
		return ;
	}

	/* Prepare the ImageStartCmd packet */
	asc.type = _IS_Data ;
	asc.port = port ;
	asc.gid = id ;

	ln = sizeof(IS_Data) ;
	buf = (char *)Malloc(ln) ;
	bcopy((char *)&asc, (char *)buf, sizeof(IS_Data) ) ;

	/* Send the command to all fds except the client ( originator) */
	for ( j=0; j< n_fds; j++)
	{
	
		if (fd_arr[j] == client) 
			continue ;
		WriteToClient( fd_arr[j], ln, (char *)buf) ;
	}
	Free(buf) ;

	/* Wait for connections from these fds */
	imgfds_count =  0;
	for ( j=0 ; j<n_fds; j++)
	{
		isock = accept(imgsockfd, (struct sockaddr *)&cli_addr, &clilen) ;
		if (isock < 0)
		{
			perror("Server: accept error on audio socket ") ;
			CloseDownServer () ; /*WORKHERE*/ 
		}

		/*Add the fd to the audio fds array */
		groupimgfds[id][imgfds_count++] = isock ;
	}

	return ;
}

/*---------------------------------------------ProcessImageDataReq()----------*/
/*----------------------------------------------------------------------------*/
void	ProcessImageDataReq( tReq_ptr, client)
T_Req	*tReq_ptr ;
FD				client ;
{

	LL_SendDataReq	ll ;
	char			*buf, *pBuf, *data ;
	char			*uname ;
	int				ln, j, i;
	FD				*fd_arr ;
	int				n_fds ;
	T_Data			td ;

	bcopy((char *)tReq_ptr, (char *)&ll, sizeof(T_Req)) ;
	
	/*Read the Data from Image Port */
	{
	int	len ;

	len = (ntohs(ll.nBytes) + 3) & ~3 ;
	data = (char *)Malloc(len) ;
	
	ReadBuffer(client, data, len) ;
	}

	/* Do any server data update here*//*WORKHERE*/ 	
	ImageIndex[ll.gid] ++ ;

	/* the image channle fd is not stored in the pinfo table ..
	so cannot get username from there*/
	UserName( ImageGenFD[ll.gid], &uname) ; 

	/* HISTORY FILE *//*WORKHERE*/ 
	WriteHistFileImage( ll.gid, ImageGenFD[ll.gid], ll.image_type, ll.pkts_left, 
			uname, data, ll.nBytes) ;

	td.type = _I_Data ;
	td.image_type = ll.image_type ;
	td.gid = ll.gid ;
	td.nBytesData	= ll.nBytes ;
	td.pkts_left = ll.pkts_left ;
	td.nBytesUser = htons(strlen(uname)) ; 
	td.MsgNum = 0 ;
	td.ImgIndx = ImageIndex[ll.gid] ;

	/*Find out the clients of the group */
	if(DistribImgSocks((int)td.gid, &fd_arr, &n_fds, client) != SUCCESS)
	{
		ERROR("DISTRIBSOCKS FAILED") ;
		CloseDownClient(client) ;
		return ;
	}

	ln = sizeof(T_Data) + ((td.nBytesData +3) & ~3) +
			((td.nBytesUser + 3) & ~3) ;

	/* Make the packet to send */
	buf = (char *)Malloc(ln) ;
	pBuf = buf ;
	bcopy((char *)&td, (char *)buf, sizeof(T_Data)) ;
	pBuf += sizeof(T_Data) ;

	/*Copy the data*/
	bcopy((char *)data, (char *)pBuf, ntohl(td.nBytesData)) ;
	pBuf += ntohl(td.nBytesData);
	i = padlength[ntohl(td.nBytesData) & 3] ;
	while ( --i >= 0) 
		*pBuf++ = 0 ;

	/* The user name */
	bcopy((char *)uname, (char *)pBuf, ntohs(td.nBytesUser )) ;
	pBuf += ntohs(td.nBytesUser) ;
	i = padlength[ntohs(td.nBytesUser) & 3] ;
	while( --i >= 0)
		*pBuf++ = 0 ;

	/*Sending to all clients*/
	for(j=0; j<n_fds-1; j++)
	{
		if((FD)fd_arr[j] == client)
			continue ;

		WriteToClient( fd_arr[j], ln, (char *)buf) ;
	}

	Free(buf) ;
	Free(data) ;

	/* Set the image channel to free is last pkt passed */
	if ( td.pkts_left == 0 ) 
	{
		image_channel_status[td.gid] = FREE ;

		for(j=0; j<n_fds-1;j++)
			close(fd_arr[j]) ;

		RemoveFD(client) ;
		close(imgsockfd) ;
	}

	return ;
	
}

int	ifname_check(fp)
FILE	*fp ;
{
	int	c;
	if ((c=fgetc(fp)) == ImageFileFlag)
		return(TRUE) ;
	else
	{
		ungetc(c, fp) ;
		return (FALSE) ;
	}
}

void	send_image_history( client, grp_id, filename, pkts_left, sender, img_type)
FD	client ;
int	grp_id ;
char	*filename ;
int	pkts_left ;
char	*sender ;
int 	img_type ;
{
	char	*data ;
	char	*dbuf , *pBuf;
	T_Data 		tdata ;
	int	i ;
	char	usrname[82], hostname [8];
	FILE	*fp ;
	struct	stat	fbuf ;
	int	ln;

	if ( (fp = fopen(filename,"r")) == NULL)
	{
		/*do error processing */
		return ;
	}
	else
	{
		fstat( fileno(fp), &fbuf) ;
		data = (char *) Malloc( fbuf.st_size * sizeof(char) ) ;

		read( fileno(fp), data, fbuf.st_size) ;
	}
	
	/* Now send the data */		
	strcpy(usrname,sender) ;
	strcpy(hostname,"none") ;
				
	/*Set the tdata parameters*/
	tdata.type=_HI_Data ;
	tdata.nBytesUser = htons(strlen(usrname)) ;
	tdata.gid = grp_id ;
	tdata.pkts_left = htons(pkts_left );
	tdata.image_type = (unsigned char)img_type ;

	tdata.nBytesData = htonl(fbuf.st_size);

	/* Make the packet to send */

	ln = sizeof(T_Data)
		+ (( ntohl(tdata.nBytesData )+ 3) & ~3)
		+ (( ntohs(tdata.nBytesUser) + 3) & ~3)
		;

	dbuf = (char *)Malloc (ln) ;


	pBuf = dbuf;
	bcopy((char *)&tdata, (char *)dbuf,sizeof(T_Data));

	pBuf += sizeof(T_Data);

	bcopy((char *)data, (char *)pBuf,ntohl(tdata.nBytesData));

	pBuf += ntohl(tdata.nBytesData);

	i = padlength[ntohl(tdata.nBytesData) & 3];

	while(--i >= 0)
		*pBuf++ = 0;

	while(--i >= 0)
		*pBuf++ = 0;

	bcopy((char *)usrname,(char *)pBuf,strlen(usrname));

	pBuf += strlen(usrname) ;

	i = padlength[strlen(usrname)& 3];

	while(--i >= 0)
		*pBuf++ = 0;

	/*****MADE the Packet, now send it***/
	WriteToClient(client, ln,(char *) dbuf) ;

	Free(dbuf) ;
	Free(data) ;

}

/* This routine forms the packet reqd. to send */
void	make_packet( tdata, data, dbuf)
T_Data	*tdata ;
char	*data ;
char	**dbuf ;
{

	int sizesofar,i;
	char	*pbuf ;

	sizesofar=0 ;
 
	pbuf = (*dbuf );
	bcopy((char *)tdata, (char *)pbuf, sizeof(T_Data)) ;

	pbuf = pbuf + sizeof(T_Data) ;
 
	sizesofar = sizesofar + sizeof(T_Data) ;
 
	bcopy ((char *)data, (char *)pbuf,tdata->nBytesData) ;
 
	pbuf = pbuf + (tdata->nBytesData) ;
	sizesofar = sizesofar + tdata->nBytesData ;
 
	i = padlength[tdata->nBytesData & 3] ;
	sizesofar += i ;
	while (--i >= 0)
		*pbuf++ = 0 ;

}
 
 

/*---------------------------------------------End of process_reqs.c----------*/
